/*
 *
 *
 *
 */

#include "sim.h"



struct pcbreakpoint_s *pcbreakpoints = NULL;

int pcbp_add(unsigned int pc)
{
  struct pcbreakpoint_s *cur = pcbreakpoints;
  struct pcbreakpoint_s *new;

  if (!(new = calloc(1, sizeof(struct pcbreakpoint_s))))
    return -1;

  new->pc = pc;
  new->next = NULL;

  if(!pcbreakpoints)
    pcbreakpoints = new;
  else
    {
      for(cur=pcbreakpoints; cur->next != NULL; cur = cur->next)
	;
      cur->next = new;
    }
  return 0;
}

int pcbp_check(unsigned int pc)
{
  struct pcbreakpoint_s *cur;
  for(cur=pcbreakpoints;cur!=NULL;cur=cur->next)
    {
      if (cur->pc == pc)
	return 1;
    }
  return 0;
}

int pcbp_dump(void)
{
  struct pcbreakpoint_s *cur;

  fprintf(stderr, "pcbp: -- PC Breakpoints ------------------------\n");
  for(cur=pcbreakpoints;cur!=NULL;cur=cur->next)
    fprintf(stderr, "pcbp: %03x\n", cur->pc);
  fprintf(stderr, "pcbp: ------------------------------------------\n");
  return 0;
}

